(PackageInfo named: 'ContextS2') postscriptOfRemoval: '"below, add code to clean up after the unloading of this package"'!
(PackageInfo named: 'ContextS2') preamble: '"below, add code to be run before the loading of this package"
'!
SystemOrganization addCategory: #ContextS2!
SystemOrganization addCategory: #'ContextS2-Tests'!
SystemOrganization addCategory: #'ContextS2-Tests-Sandbox'!
(PackageInfo named: 'ContextS2') postscript: ''!
(PackageInfo named: 'ContextS2') preambleOfRemoval: '"below, add code to prepare for the unloading of this package"'!

!MCMethodDefinition methodsFor: '*ContextS2' stamp: 'tfel 2/23/2012 19:09:07.297'!
selector: aSymbol

	selector := aSymbol! !

!Process methodsFor: '*ContextS2' stamp: 'tfel 2/23/2012 14:49:20.42'!
csInfo
	"Only the contents of csInfo are accessed, thus no need for a setter in Process"
	
	^ self
		environmentAt: #csInfo
		ifAbsent: [self environmentAt: #csInfo put: CSProcessContextInformation new]! !

!Parser class methodsFor: '*ContextS2-override-accessing' stamp: 'ag 12/20/2011 21:39'!
primitivePragmaSelectors
	"Answer the selectors of pragmas that specify VM primitives.
	 Needed for compile and decomple."
	^#(primitive:
		primitive:error:
		primitive:error:module:
		primitive:module:
		primitive:module:error:
		), CSLayeredMethod pragmaKeyword! !

!Parser methodsFor: '*ContextS2' stamp: 'ag 12/20/2011 21:40'!
layer: aCollectionOfLayers
	^ 0! !

!CompiledMethodWithNode class methodsFor: '*ContextS2-override-instance creation' stamp: 'ag 12/20/2011 21:39'!
generateMethodFromNode: aMethodNode trailer: bytes
	
	| method |
	method := aMethodNode generate: bytes.
	(method pragmas anySatisfy: [:each | each keyword = CSLayeredMethod pragmaKeyword ])
		ifTrue: [method := method asPartialMethod].
	^ self method: method node: aMethodNode.! !

!CompiledMethod methodsFor: '*ContextS2' stamp: 'ag 2/1/2012 16:19:51.427'!
asPartialMethod
	
	| layer |
	layer := self layersPragma
		ifNotNilDo: [ :pragma |
			pragma arguments size == 1 ifFalse: [ self error: 'Illegal ContextS2-Pragma: Need only one argument.' ].
			layer := pragma argumentAt: 1.
			(layer isSymbol | (layer isArray and: [ layer allSatisfy: #isSymbol ]))
				ifFalse: [ self error: 'Illegal ContextS2-Pragma: Need Symbol or Array of Symbols as parameter.' ].
			layer isArray ifTrue: [ layer ] ifFalse: [ Array with: layer ] ].
	^ CSPartialMethod
				on: layer
				forMethod: self! !

!CompiledMethod methodsFor: '*ContextS2' stamp: 'tfel 2/23/2012 17:46:49.222'!
asSymbol

	^ self selector! !

!CompiledMethod methodsFor: '*ContextS2' stamp: 'ag 2/1/2012 16:19:44.324'!
layersPragma
	
	^ self pragmas
		detect: [ :each | each keyword == CSLayeredMethod pragmaKeyword ]
		ifNone: [ nil ]! !

!Behavior methodsFor: '*ContextS2' stamp: 'tfel 2/28/2012 15:05:58.093'!
allCompiledMethods

    ^ Array streamContents: [:stream |
        self withAllSuperclassesDo: [:aClass |
            aClass methodsDo: [:method | 
                stream nextPut: method]]]! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 1/12/2012 12:55'!
allInvolvedLayers
	
	| layers |
	layers := Set new.
	methodDict values
		select: [ :each | each class == CSLayeredMethod ]
		thenDo: [ :each | layers addAll: each allInvolvedLayers ].
	^ layers! !

!Behavior methodsFor: '*ContextS2-override-adding/removing methods' stamp: 'tfel 2/23/2012 14:36:48.626'!
basicAddSelector: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the receiver's method dictionary. Do this without sending system change notifications"
	
	| oldMethodOrNil method |
	oldMethodOrNil := self lookupSelector: selector.
	"Empty symbols are used by Object >> withArgs:executeMethod: to temporarily store a method in the methodDict; avoid creating the LayeredMethod."
	"the >>respondsTo: check allows us to load this in one Mcz without the need for a postload package"
	(selector notEmpty and: [self respondsTo: #contextSConversionOld:new:])
		ifFalse: [ method := compiledMethod ]
		ifTrue: [
			compiledMethod methodClass: self; selector: selector.
			method := self
				contextSConversionOld: (self compiledMethodAt: selector ifAbsent: [ nil ])
				new: compiledMethod.
			method methodClass: self; selector: selector ].
	self methodDict at: selector put: method.
	
	"Now flush Squeak's method cache, either by selector or by method"
	oldMethodOrNil == nil ifFalse: [oldMethodOrNil flushCache].
	selector flushCache.! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/23/2011 16:53'!
contextSConversionOld: old new: new
	"old can be nil or a CompiledMethod or a CSLayeredMethod. new can be a CompiledMethod or a CSPartialMethod."
	
	| layeredMethod |
	layeredMethod := (old class == CSLayeredMethod
		ifTrue: [ old ]
		ifFalse: [
			CSLayeredMethod new
				addPartialMethod: (old ifNotNil: [ old asPartialMethod ]);
				yourself ]).
	layeredMethod addPartialMethod: new asPartialMethod.
	^ layeredMethod isLayered
		ifTrue: [ layeredMethod ]
		ifFalse: [ new ] "use the CompiledMethod, if LayeredMethod would be useless."! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/11/2011 16:43'!
cs2FileOut
	
	self cs2FileOutOn: (FileStream forceNewFileNamed: self name asString, '.st').! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/11/2011 09:59'!
cs2FileOutCompiledMethod: compiledMethod called: aSelector of: aClass on: aStream
	
	self
		cs2FileOutMultiPart: 
			{ 
			aClass name, ' methodsFor: ''', (aClass organization categoryOfElement: aSelector), ''''.
			compiledMethod getSource
			}
		on: aStream.! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/20/2011 20:33'!
cs2FileOutMethod: meth called: aSelector of: aClass on: stream
	
	(meth isKindOf: CSLayeredMethod)
		ifTrue: [ meth partialMethods do: [ :partialMethod | self cs2FileOutCompiledMethod: partialMethod method called: aSelector of: aClass on: stream ] ]
		ifFalse: [ self cs2FileOutCompiledMethod: meth called: aSelector of: aClass on: stream ]! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/11/2011 09:57'!
cs2FileOutMultiPart: aCollectionOfStrings on: stream
	
	stream nextPut: $!!; cr.
	aCollectionOfStrings
		do: [ :str | self cs2FileOutPart: str on: stream ].
	stream nextPut: $!!; cr.! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/11/2011 10:07'!
cs2FileOutOn: stream
	
	self cs2FileOutPart: self definition on: stream.
	self methodDict keysAndValuesDo: [ :selector :meth |
		self cs2FileOutMethod: meth called: selector of: self on: stream ].! !

!Behavior methodsFor: '*ContextS2' stamp: 'ag 12/11/2011 09:56'!
cs2FileOutPart: aString on: stream
	
	| tokens |
	tokens := aString asString findTokens: '!!' keep: '!!'.
	tokens do: [ :str |
		stream nextPutAll: 
			(str = '!!'
				ifTrue: [ '!!!!' ]
				ifFalse: [ str ]) ].
	stream nextPut: $!!; cr; cr.! !

!PackageInfo methodsFor: '*ContextS2' stamp: 'tfel 2/23/2012 19:26:11.397'!
layeredMethods
	| coreMethods extensionMethods |
	coreMethods := self classesAndMetaClasses gather: [:class |
		class methodDict values select: [:method | method isContextSMethod]].
	extensionMethods := (self externalBehaviors gather: [:classOrTrait |
		(self extensionCategoriesForClass: classOrTrait)
			gather: [:cat | (classOrTrait organization listAtCategoryNamed: cat)
				collect: [:selector || method |
					method := classOrTrait methodDict at: selector.
					method isContextSMethod ifTrue: [method]]]])
		reject: #isNil.
	^ (coreMethods, extensionMethods) gather: [:method |
			method partialMethods collect: [:m |
				CSMethodReference onMethod: m]]! !

!PackageInfo methodsFor: '*ContextS2-override-listing' stamp: 'tfel 2/23/2012 18:50:23.126'!
methods
	^ ((self extensionMethods, self coreMethods) select: [:method |
		method isValid
			and: [method isLocalSelector
			and: [method methodSymbol isDoIt not]]]), self layeredMethods! !

Object subclass: #CSClassA
	instanceVariableNames: 'executedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassA methodsFor: 'accessing' stamp: ''!
executed: aSymbol

	self executedMethods add: aSymbol.! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethods
	"Answer the value of executedMethods"

	^ executedMethods! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethods: anObject
	"Set the value of executedMethods"

	executedMethods := anObject! !

!CSClassA methodsFor: 'accessing' stamp: ''!
executedMethodsArray

	^ self executedMethods asArray! !

!CSClassA methodsFor: 'partial methods' stamp: 'ag 1/30/2012 13:12:04.291'!
getCurrentLayerA
	
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerA
	<layer: #a>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerAB
	<layer: #(a b)>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerBA
	<layer: #(b a)>
	^ self currentLayers! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #a>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #additional>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
getCurrentLayerOf: aSymbol on: aLayer
	<layer: #b>
	aLayer withLayerDo: [ ^ self perform: aSymbol ].! !

!CSClassA methodsFor: 'initialize-release' stamp: ''!
initialize
	
	self executedMethods: OrderedCollection new.! !

!CSClassA methodsFor: 'partial methods' stamp: 'ag 1/30/2012 13:10:00.309'!
myMethod
	
	self executed: #base.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #after>
	self proceed.
	self executed: #after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #before>
	self executed: #before.
	self proceed.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #proceed1>
	self executed: #proceed1before.
	self proceed.
	self executed: #proceed1after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #proceed2>
	self executed: #proceed2before.
	self proceed.
	self executed: #proceed2after.! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod
	<layer: #replace>
	self executed: #replace! !

!CSClassA methodsFor: 'partial methods' stamp: 'ag 1/30/2012 13:18:07.175'!
myMethod: arg1 and: arg2
	
	^ arg1 + arg2! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod: arg1 and: arg2
	<layer: #someLayer>
	
	^ (self proceed: arg1 with: arg2) + 1! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myMethod: arg1 and: arg2
	<layer: #someLayer2>
	
	^ (self proceed: arg1 with: arg2) + 1! !

!CSClassA methodsFor: 'partial methods' stamp: 'ag 1/30/2012 13:15:18.484'!
myReturnMethod
	
	^ #base! !

!CSClassA methodsFor: 'partial methods' stamp: ''!
myReturnMethod
	<layer: #replacedReturn>
	^ #replacedReturn! !

!CSClassA methodsFor: 'non local return' stamp: ''!
nonLocalReturn
	|  aBlock |
	aBlock :=  [^ false].
	#l1 withLayerDo: [self valueBlock: aBlock].! !

!CSClassA methodsFor: 'non local return' stamp: ''!
valueBlock: aBlock

	aBlock value.! !

Object subclass: #CSClassB
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassB methodsFor: 'accessing' stamp: ''!
count

	^ count! !

!CSClassB methodsFor: 'initialize-release' stamp: ''!
initialize

	count := 1.! !

CSClassB subclass: #CSSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

Object subclass: #CSLayer
	instanceVariableNames: 'layerName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:22'!
checkIsSubclass
	
	self == CSLayer ifTrue: [ self error: 'Cannot access singleton-instance of CSLayer itself.' ].! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:33'!
getGlobalInstanceOf: aClass withName: aSymbol
	
	^ (Smalltalk includesKey: aSymbol)
		ifTrue: [ | layer |
			layer := Smalltalk at: aSymbol.
			(layer isKindOf: CSLayer)
				ifTrue: [
					layer class == aClass
						ifTrue: [ layer ]
						ifFalse: [ "Delete obsolete CSLayer instances. Kind of a side case, but keeps the system clean."
							Smalltalk removeKey: aSymbol.
							self getGlobalInstanceOf: aClass withName: aSymbol ] ]
				ifFalse: [ self error: 'Global ', aSymbol, ' already exists, cannot create layer with that name.' ] ]
		ifFalse: [
			Smalltalk at: aSymbol put: (aClass basicNew initialize: aSymbol; yourself) ] "Avoid #new"! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'ag 12/22/2011 16:22'!
globalLayerName
	"The name of the layer to be accessed as a global variable. Is accessible as soon as instance has been invoked."
	
	self subclassResponsibility.! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'ag 12/23/2011 14:29'!
instance
	"Singleton-pattern with registration in the global namespace.
	Only for subclasses of CSLayer, CSLayer itself has multiple 'anonymous' instances (which are also registered globally)"
	
	self checkIsSubclass.
	^ self
		getGlobalInstanceOf: self
		withName: self globalLayerName! !

!CSLayer class methodsFor: 'layers' stamp: 'ag 12/23/2011 14:29'!
layerNamed: aSymbol
	"Return the CSLayer-instance associated with aSymbol.
	If a subclass with the according globalLayerName exists, it's singleton-instance is returned.
	Else, an anonymous instance of CSLayer is returned. These objects are created lazily, tracked in a dictionary and freed when become obsolet.e."
	
	^ (self subclassedLayerNamed: aSymbol)
		ifNotNilDo: #instance
		ifNil: [
			self
				getGlobalInstanceOf: CSLayer
				withName: aSymbol ]! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/22/2011 15:54'!
new
	
	^ self error: 'Dont create instances of CSLayer (or subclasses) manually.'! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:23'!
pvtCreateNamed: aSymbol
	"Only internal, for controlled instance creation."
	
	^ self basicNew initialize: aSymbol; yourself! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:32'!
removeGlobalInstanceNamed: aSymbol
	
	^ ((Smalltalk at: aSymbol ifAbsent: [ ^ nil ]) isKindOf: CSLayer)
		ifTrue: [ Smalltalk removeKey: aSymbol ]
		ifFalse: [ self error: 'Global ', aSymbol, ' is not an instance of CSLayer' ]! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'ag 12/23/2011 14:26'!
resetInstance
	"Reset the layer-instance of this class. Only applicable for subclasses."
	
	self checkIsSubclass.
	^ self removeGlobalInstanceNamed: self globalLayerName! !

!CSLayer class methodsFor: 'layers' stamp: 'ag 12/23/2011 14:26'!
resetLayer: aSymbol
	"Resets the global layer-instance named by aSymbol. Takes layers with their own subclass and anonymous layers into account."
	
	^ (self subclassedLayerNamed: aSymbol)
		ifNotNilDo: #resetInstance
		ifNil: [ self removeGlobalInstanceNamed: aSymbol ]! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:11'!
subclassedLayerNamed: aSymbol
	
	^ self allSubclasses
		detect: [ :cl | cl globalLayerName = aSymbol ]
		ifNone: [ nil ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:14'!
allContainingLayeredMethods
	
	^ CSLayeredMethod allInstances
		select: [ :method |
			method partialMethods
				anySatisfy: [ :partial | partial layers includes: self layerName ] ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:16'!
allContainingMethods
	"Returns a collection of associations from class to selector."
	
	^ self allContainingLayeredMethods
		collect: [ :layeredMethod | layeredMethod methodClass -> layeredMethod selector ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:52'!
allContainingPartialMethods
	
	| result |
	result := OrderedCollection new.
	self allContainingLayeredMethods
		do: [ :layeredMethod |
			result addAll:
				(layeredMethod partialMethods
					select: [ :partialMethod | partialMethod layers includes: self layerName ]) ].
	^ result! !

!CSLayer methodsFor: 'queries' stamp: 'ag 1/22/2012 14:52:09.315'!
asLayer
	"Also implemented on Symbol, to transparently access this first-class layer object."
	
	^ self! !

!CSLayer methodsFor: 'initialization' stamp: 'ag 12/22/2011 17:18'!
initialize
	
	self error: 'Please use the #initialize: message with the layer-name as parameter.'.! !

!CSLayer methodsFor: 'initialization' stamp: 'ag 12/22/2011 17:18'!
initialize: aSymbol
	
	super initialize.
	layerName := aSymbol.! !

!CSLayer methodsFor: 'accessing' stamp: 'ag 12/22/2011 17:16'!
layerName
	
	^ layerName! !

!CSLayer methodsFor: 'layer handling' stamp: 'ag 12/23/2011 15:33'!
reset
	"Reset the layer-instance. Next time the layer will be accessed, it will result in another object."
	
	^ self class resetLayer: self layerName! !

!CSLayer methodsFor: 'layer handling' stamp: 'ag 1/27/2012 16:49:15.994'!
withLayerDo: aBlock
	"Pass the call on to the name-symbol. TODO in future, the functionality should be replaced here, in the Layer-class."
	
	^ self layerName withLayerDo: aBlock! !

CSLayer subclass: #CSTestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestLayer class methodsFor: 'layer instances' stamp: 'ag 12/22/2011 16:40'!
globalLayerName
	
	^ #cstest! !

Object subclass: #CSMethodObject
	instanceVariableNames: 'methodClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

CSMethodObject subclass: #CSLayeredMethod
	instanceVariableNames: 'baseMethod partialMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSLayeredMethod class methodsFor: 'consistency' stamp: 'tfel 2/29/2012 10:16:13.666'!
checkConsistencyOfInstances
	"self checkConsistencyOfInstances"
	
	super checkConsistencyOfInstances.
	[ CSLayeredMethod allInstances
		allSatisfy: [ :method |
			method partialMethods class == OrderedCollection ]
	] assert.

	[ CSLayeredMethod allInstances
		allSatisfy: [ :method |
			(method isLayered) or: [
			(method methodClass methodDict includes: method) not] ]
	] assert.! !

!CSLayeredMethod class methodsFor: 'consistency' stamp: 'ag 1/30/2012 13:05:45.269'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	
	super fixConsistencyOfInstances.
	[ CSLayeredMethod allInstances
		do: [ :method | "Replace the collection-instance in the CSLayeredMethod-instance by a Set."
			method setPartialMethods: (OrderedCollection withAll: method partialMethods) ].
	] on: Error do: [ :e | Transcript cr; show: 'Fixing partialMethods-collection of all subinstances of CSLayeredMethod failed: ', e ].
	
	[ CSLayeredMethod allInstances
		do: [ :method | "Replace CSLayeredMethods, that do not actually include layered behaviour, by simple CompiledMethods."
			method isLayered ifFalse: [ method becomeCompiledMethod ] ].
	] on: Error do: [ :e | Transcript cr; show: 'Turning all non-layered subinstances of CSLayeredMethod into CompiledMethods failed: ', e ].! !

!CSLayeredMethod class methodsFor: 'constants' stamp: 'ag 12/20/2011 21:39'!
pragmaKeyword
	
	^ #layer:! !

!CSLayeredMethod class methodsFor: 'constants' stamp: 'ag 12/23/2011 16:08'!
proceedSelectorBase
	
	^ #proceed! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 12/17/2011 21:50'!
activeLayers
	
	^ Processor activeProcess csInfo activeLayers! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 2/28/2012 15:45:04.655'!
addPartialMethod: aPartialMethod

	aPartialMethod ifNil: [ ^ self ].
	aPartialMethod isBase
		ifTrue: [ baseMethod := aPartialMethod ]
		ifFalse: [
			(self hasConflictsWithPartialMethod: aPartialMethod) ifFalse: [
				self partialMethods
					remove: aPartialMethod ifAbsent: [ "nothing" ];
					add: aPartialMethod ]].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/12/2012 13:00'!
allInvolvedLayers
	
	| layers |
	layers := Set new.
	self partialMethods
		do: [ :each | layers addAll: each layers ].
	^ layers! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'ag 1/30/2012 16:30:13.142'!
allPartialMethods
	"Return the partial methods in this layered method, inclusive the base-method.
	Returned collection may not be modified, as the internal partial-method-collection may be returned without copying."
	
	^ self includesBaseMethod
		ifTrue: [ self partialMethods copyWith: baseMethod ]
		ifFalse: [ self partialMethods ]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:33:16.835'!
baseMethod
	"This does NOT return just the instance field, but unpacks the CompiledMethod from the CSPartialMethod."
	
	^ baseMethod ifNotNilDo: #method! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:28:31.056'!
basePartialMethod
	
	^ baseMethod! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'ag 1/30/2012 13:39:48.601'!
becomeCompiledMethod
	"This restores the consistency of this object, if it is not layered anymore. First check, if the receiver is still inside its class' methodDict.
	Then, if we have any partial method left, put it's CompiledMethod in the methodDict; else, just delete the slot.
	If this is called while #isLayered returns true, some of the partial methods will just get lost."
	
	(self methodClass methodDict at: self selector ifAbsent: [ nil ]) == self ifFalse: [ ^ self ].
	self includesAnyPartialMethod ifFalse: [ self methodClass methodDict removeKey: self selector ifAbsent: [ "nothing" ] ].
	self compiledMethodReplacement ifNotNilDo: [ :compiledMethod |
		self methodClass methodDict
			at: self selector
			put: compiledMethod ].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 13:39:21.924'!
compiledMethodReplacement
	
	^ self includesAnyPartialMethod ifTrue: [
		self includesBaseMethod
			ifTrue: [ self baseMethod ]
			ifFalse: [ self partialMethods anyOne method ] ]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/20/2012 22:44:40.615'!
hasBaseMethod
	
	^ self baseMethod notNil! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 2/28/2012 15:48:52.912'!
hasConflictsWithPartialMethod: aPartialMethod

	^ self partialMethods
			detect: [:method | method layers ~= aPartialMethod layers and: [
								method layers includesAnyOf: aPartialMethod layers]]
			ifFound: [:method |
				((self confirm: 'This will override another method that defines the layers ',
								(method layers intersection: aPartialMethod layers))
					ifTrue: [self partialMethods remove: method. false]
					ifFalse: [true])]
			ifNone: [false]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/23/2012 08:35:04.233'!
includesAnyPartialMethod
	"Return true, if any behaviour is still left in this layered method."
	
	^ self includesBaseMethod | self partialMethods notEmpty! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:31:49.261'!
includesBaseMethod
	
	^ self baseMethod notNil! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:24:33.091'!
isLayered
	"Returns true, if this layered method currently does anything different than a simple CompiledMethod.
	If false, this layered method should be replaced by an equivalent CompiledMethod.
	This is the case, if there are no partial methods."
	
	^ self partialMethods notEmpty! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:30:48.529'!
method
	"Use base method, if possible, else use any partial method. Return nil, if not a single partial method is present."
	
	^ self includesBaseMethod
		ifTrue: [ self baseMethod ]
		ifFalse: [ self partialMethods ifNotEmpty: [ self partialMethods anyOne ] ifEmpty: [ nil ] ]! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'tfel 2/28/2012 15:58:15.156'!
methodChainFor: activeLayers
	"Chain together all partial methods that are currently active. Chain is ordered in the way the layers have been activated."
	
	| methodChain applicableMethods layeredMethods |
	methodChain := OrderedCollection new.
	applicableMethods := self methodClass allCompiledMethods
								select: [:method | method selector = self selector].
	layeredMethods := (applicableMethods
							select: #isContextSMethod)
							gather: [:layeredMethod | layeredMethod partialMethods].
	(activeLayers do: [ :layer |
		(layeredMethods
			detect: [:method | method layers includes: layer]
			ifFound: [:method | methodChain addIfNotPresent: method]
			ifNone: [])]).
	(applicableMethods
		detect: [:method | method isContextSMethod not or: [
							method includesBaseMethod]]
		ifFound: [:method | methodChain add: (method isContextSMethod 
												ifTrue: [method baseMethod]
												ifFalse: [method])]
		ifNone: ["doesn't matter"]).
	^ methodChain! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/27/2012 17:07:35.681'!
partialMethods
	
	^ partialMethods ifNil: [ partialMethods := OrderedCollection new ]! !

!CSLayeredMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:25'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ', ';
		nextPutAll: (self partialMethods size + (self includesBaseMethod ifTrue: [ 1 ] ifFalse: [ 0 ])) asString;
		nextPutAll: ' version(s))'.! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'ag 12/25/2011 18:07'!
proceedSelector
	
	| selector |
	selector := self class proceedSelectorBase.
	self selector isUnary ifTrue: [ ^ selector asSymbol ].
	selector := selector, #':'.
	self selector isInfix ifTrue: [ ^ selector asSymbol ].
	(self selector occurrencesOf: $:) - 1
		timesRepeat: [ selector := selector, #with: ].
	^ selector asSymbol! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'nw 1/22/2012 15:26'!
registerProceed: aReceiver
	"If no ProceedMethod-instance was in the method-dictionary, create one and insert it. If #proceed: was implemented otherwise, throw an error."
	
	(aReceiver class methodDict
		includesKey: self proceedSelector)
		ifTrue: [ | partialMethod |
			partialMethod := aReceiver class methodDict at: self proceedSelector.
			partialMethod class == CSProceedMethod
				ifFalse: [ self error: 'ContextS may not be used with classes implementing #', self proceedSelector ].
			partialMethod incrementRunningLayeredMethods ]
		ifFalse: [
			self flag: #ag. "Access to methodDict should be synchronized on a semaphore. See also #unregisterProceed:"
			aReceiver class methodDict
				at: self proceedSelector
				put: (CSProceedMethod selector: self proceedSelector class: self class) ]. "Default runningLayeredMethods is 1."! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'ag 1/30/2012 16:32:19.148'!
removePartialMethod: aPartialMethod
	
	aPartialMethod method == self baseMethod
		ifTrue: [ baseMethod := nil ]
		ifFalse: [ self partialMethods remove: aPartialMethod ifAbsent: [] ].
	self isLayered ifFalse: [ self becomeCompiledMethod ].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 16:48:23.532'!
setPartialMethods: aCollection
	"Only for internal use."
	
	partialMethods := aCollection! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'ag 12/23/2011 16:10'!
unregisterProceed: aReceiver
	"We are finished using the ProceedMethod instance. Decrease its counter and remove it from the method-dictionary if necessary."
	
	(aReceiver class methodDict
		at: self proceedSelector
		ifAbsent: [ ^ self ])
		ifNotNilDo: [ :proceedMethod |
			(proceedMethod isKindOf: CSProceedMethod)
				ifTrue: [
					proceedMethod decrementRunningLayeredMethods.
					proceedMethod runningLayeredMethods <= 0
						ifTrue: [ 
							self flag: #ag. "Access to methodDict should be synchronized on a semaphore. See also #registerProceed:"
							aReceiver class methodDict removeKey: self proceedSelector ] ] ].! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'tfel 2/28/2012 15:26:06.403'!
valueWithReceiver: aReceiver arguments: anArray
	"Memorize old method-chain, compute a new one, kick off the execution and restore the old state afterwards."
	
	| oldProcessState methodChain |
	methodChain := self methodChainFor: self activeLayers.
	methodChain ifEmpty: ["Not a single method to execute..."
		^ aReceiver
			doesNotUnderstand: (Message selector: self selector arguments: anArray) ].
	self registerProceed: aReceiver.
	oldProcessState := Processor activeProcess csInfo saveState.
	Processor activeProcess csInfo methodChain: methodChain.
	^ [ methodChain first valueWithReceiver: aReceiver arguments: anArray ]
		ensure: [
			self unregisterProceed: aReceiver.
			Processor activeProcess csInfo restoreStateFrom: oldProcessState ]! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:52:04.164'!
checkAllInstances
	
	Smalltalk garbageCollect. "As the check/fix methods use allInstances/allSubInstances, we should try to collect all obsolete instances."
	^ CSMethodObject allSubclassesDo: #checkConsistencyOfInstances! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/30/2012 12:52:38.416'!
checkConsistencyOfInstances
	"self checkConsistencyOfInstances"
	
	[ self allInstances
		noneSatisfy: [ :method |
			method selector isNil or: [ method selector isEmpty ]
			or: [ method methodClass isNil ] ]
	] assert.! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:51:48.267'!
fixAllInstances
	
	Smalltalk garbageCollect. "As the check/fix methods use allInstances/allSubInstances, we should try to collect all obsolete instances."
	^ CSMethodObject allSubclassesDo: #fixConsistencyOfInstances! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/30/2012 12:55:08.897'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	"Sets the selector of all method-object instances to the selector of their underlying CompiledMethod."
	
	[ self allInstances do: [ :methodObject |
		methodObject selector: methodObject method selector ]
	] on: Error do: [ :e | Transcript cr; show: 'Fixing selectors on all instances of ', self, ' failed: ', e ].
	
	[ self allInstances do: [ :methodObject |
		methodObject selector ifEmpty: [ methodObject methodClass methodDict removeKey: #'' ifAbsent: [] ] ]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting instances of ', self, ' with empty selector failed: ', e ]! !

!CSMethodObject class methodsFor: 'instance creation' stamp: 'ag 12/20/2011 20:12'!
selector: aSymbol class: aClass
	
	^ self new
		selector: aSymbol;
		methodClass: aClass;
		yourself! !

!CSMethodObject methodsFor: 'converting' stamp: 'tfel 2/23/2012 17:45:41.4'!
asSymbol
	
	^ self printString asSymbol! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/19/2012 19:01:38.067'!
at: aNumber
	
	^ self method at: aNumber! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 21:19'!
doesNotUnderstand: aMessage
	"Required for all meta messages that need information from the original method."
	
	^ self method
		ifNil: [ self ] "Cannot pass the message on, simulate behavior of an empty method."
		ifNotNilDo: [ :msg | msg perform: aMessage selector withArguments: aMessage arguments ]! !

!CSMethodObject methodsFor: 'literals' stamp: 'tfel 2/29/2012 10:05:23.663'!
hasLiteral: literal

	self method ifNil: [^ false].
	^ self method hasLiteral: literal! !

!CSMethodObject methodsFor: 'literals' stamp: 'tfel 2/29/2012 10:05:35.373'!
hasLiteralThorough: literal

	self method ifNil: [^ false].
	^ self method hasLiteralThorough: literal! !

!CSMethodObject methodsFor: 'testing' stamp: 'tfel 2/23/2012 17:03:30.372'!
isContextSMethod

	^ true! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 19:58'!
method
	"Subclasses have to provide real CompiledMethod-objects as substitute for arbitrary messages. If nil is returned, these messages are dropped."
	
	^ self subclassResponsibility! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:11'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:11'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSMethodObject methodsFor: 'printing' stamp: 'ag 12/23/2011 15:26'!
printOn: aStream
	
	aStream
		nextPutAll: self class name;
		nextPutAll: '(';
		nextPutAll: (self methodClass name ifNil: [ '' ]);
		nextPutAll: '>>';
		nextPutAll: (self selector ifNil: [ #'' ]).! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/16/2011 11:45'!
run: aSelector with: anArrayOfObjects in: aReceiver
	
	^ self valueWithReceiver: aReceiver arguments: anArrayOfObjects! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:36:22.041'!
selector
	"Answer the value of selector"

	^ selector! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/31/2012 15:23:23.931'!
selector: anObject
	"Set the value of selector"
	
	selector := anObject! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/19/2012 19:01:43.145'!
size
	
	^ self method size! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 19:59'!
valueWithReceiver: aReceiver arguments: anArrayOfObjects
	"This message is sent, when the method-object has to execute itself."
	
	^ self subclassResponsibility! !

CSMethodObject subclass: #CSPartialMethod
	instanceVariableNames: 'method layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSPartialMethod class methodsFor: 'consistency' stamp: 'ag 1/30/2012 13:08:04.048'!
checkConsistencyOfInstances
	
	super checkConsistencyOfInstances.
	
	[ CSPartialMethod allInstances noneSatisfy: [ :method |
		(method methodClass methodDict at: method selector ifAbsent: [])
			== method ]
	] assert.
	
	"TODO another helpfull check would be to check, that no partial methods return true on the #isBase message..."
	"TODO Yet another check would be to check, that instances of partialMEthod, that return true from #isBase really include the layer: pragma in their CompiledMethod"! !

!CSPartialMethod class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:48:46.172'!
fixConsistencyOfInstances
	
	super fixConsistencyOfInstances.
	
	[ CSPartialMethod allSubInstances do: [ :methodObject |
		(methodObject methodClass methodDict at: methodObject selector ifAbsent: []) == methodObject
			ifTrue: [
				methodObject methodClass methodDict removeKey: methodObject selector ifAbsent: [] ] ]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting all instances of CSPartialMethod from method-dictionaries failed: ', e ].
	
	[ CSLayeredMethod allSubInstances do: [ :methodObject |
		methodObject setPartialMethods: (methodObject partialMethods reject: [ :e | e selector isEmpty ])]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting all instances of CSPartialMethod with empty selectors from their respective layered method failed: ', e ].! !

!CSPartialMethod class methodsFor: 'instance creation' stamp: 'ag 12/23/2011 16:49'!
on: aLayer forMethod: aMethod
	
	^ (self
		selector: aMethod selector
		class: aMethod methodClass)
		method: aMethod;
		layers: aLayer;
		yourself! !

!CSPartialMethod methodsFor: 'comparing' stamp: 'ag 1/30/2012 13:01:04.742'!
= anotherPartialMethod
	
	^ anotherPartialMethod class == self class
		and: [ (layers = anotherPartialMethod internalLayers) & (self selector = anotherPartialMethod selector) & (self methodClass = anotherPartialMethod methodClass) ]! !

!CSPartialMethod methodsFor: 'comparing' stamp: 'ag 1/22/2012 17:16:13.838'!
hash
	
	^ layers hash + self selector hash + self class hash! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 23:11:26.719'!
internalLayers
	"Returns the instance-variable without further checks. For internal use only."
	
	^ layers! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:17:06.694'!
isBase
	
	^ layers isNil! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:04:45.476'!
layers
	"Answer the value of layer. If it is nil, return an empty array, but DONT set the instance-variable itself!!
	The instance variable layer being nil is a marker for this partial-method to be the base-method (see #isBase)."
	
	^ layers ifNil: [ #() ]! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 2/2/2012 10:34:56.272'!
layers: anObject
	"Set the value of layer"

	anObject ifNotNil: [ anObject do: [ :symbol | CSLayer layerNamed: symbol ] ].
	layers := anObject! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method
	"Answer the value of method"

	^ method! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method: anObject
	"Set the value of method"

	method := anObject! !

!CSPartialMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:28'!
printLayersOn: stream
	
	self layers
		do: [ :each | stream nextPutAll: each ]
		separatedBy: [ stream nextPut: Character space ].! !

!CSPartialMethod methodsFor: 'printing' stamp: 'ag 1/22/2012 16:57:41.933'!
printOn: aStream
	
	aStream
		nextPutAll: selector;
		nextPutAll: ' ('.
	self isBase
		ifTrue: [ aStream nextPutAll: '<base>' ]
		ifFalse: [ self printLayersOn: aStream ].
	aStream nextPut: $).! !

!CSPartialMethod methodsFor: 'executing' stamp: 'ag 12/21/2011 00:09'!
valueWithReceiver: aReceiver arguments: anArray
	"Memorize in the process-state, that the current method has been started; execute the backing CompiledMethod in the receivers context."
	
	Processor activeProcess csInfo executedPartialMethod: self.
	^ [ aReceiver withArgs: anArray executeMethod: self method ]
		ensure: [ Processor activeProcess csInfo executedPartialMethod: nil ] "Allow garbage collection of this partial method"! !

CSMethodObject subclass: #CSProceedMethod
	instanceVariableNames: 'runningLayeredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSProceedMethod class methodsFor: 'consistency' stamp: 'ag 1/30/2012 12:53:16.454'!
checkConsistencyOfInstances
	"self checkSystemConsistency"
	
	"super checkConsistencyOfInstances." "Super-version not applicable."
	[ CSProceedMethod allInstances
		noneSatisfy: [ :method |
			method methodClass methodDict includesKey: method selector ]
	] assert.! !

!CSProceedMethod class methodsFor: 'consistency' stamp: 'ag 1/23/2012 08:42:51.977'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	"Remove all leftover instances of ProceedMethod in method-dictionaries of classes.
	ProceedMethod-instances are removed inside ensure:-blocks, but nevertheless sometimes some of them can stay somewhere in method-dictionaries..."
	
	| number |
	"super fixConsistencyOfInstances." "Super-version not applicable."
	number := 0.
	[ CSProceedMethod allInstancesDo: [ :proceed |
			(proceed methodClass methodDict includesKey: proceed selector)
				ifTrue: [
					number := number + 1.
					proceed methodClass methodDict removeKey: proceed selector ] ].
	] on: Error do: [ :e | Transcript cr; show: 'Removing all unused subinstances of CSProceedMethod failed: ', e ].
	^ number! !

!CSProceedMethod methodsFor: 'accessing' stamp: 'ag 12/20/2011 21:01'!
decrementRunningLayeredMethods
	
	runningLayeredMethods := self runningLayeredMethods - 1.! !

!CSProceedMethod methodsFor: 'accessing' stamp: 'ag 12/20/2011 21:09'!
incrementRunningLayeredMethods
	
	runningLayeredMethods := self runningLayeredMethods + 1.! !

!CSProceedMethod methodsFor: 'executing' stamp: 'ag 12/20/2011 20:58'!
method
	"There is no real CompiledMethod to pass incoming messages to."
	
	^ nil! !

!CSProceedMethod methodsFor: 'executing' stamp: 'ag 12/23/2011 15:55'!
nextPartialMethod
	"Based on executedPartialMethod, find the next method in the methodChain."
	
	| info index |
	info := Processor activeProcess csInfo.
	index := info methodChain indexOf: info executedPartialMethod.
	info methodChain size <= index ifTrue: [ ^ nil ]. "Method chain has been executed to the end."
	^ info methodChain at: index + 1! !

!CSProceedMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:31'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ', count ';
		nextPutAll: (runningLayeredMethods ifNil: [ 0 ]) asString;
		nextPut: $).! !

!CSProceedMethod methodsFor: 'accessing' stamp: 'ag 12/20/2011 21:11'!
runningLayeredMethods
	"The default value is 1 to account for the layered method that created this proceed-method."
	
	^ runningLayeredMethods ifNil: [ runningLayeredMethods := 1 ]! !

!CSProceedMethod methodsFor: 'executing' stamp: 'nw 1/19/2012 19:22'!
valueWithReceiver: aReceiver arguments: anArray
	
	^ self nextPartialMethod
		ifNil: [ aReceiver ] "No method to proceed to. Simulate behavior of an empty method. Either the base method has called proceed: or there is no base method."
		ifNotNilDo: [ :partialMethod |
			aReceiver withArgs: anArray executeMethod: partialMethod ]! !

Object subclass: #CSMyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
bla! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
bla
	<layer: #l4>! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
blub
	"BASE"! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
blub
	<layer: #(l1 l2 l5)>
	self blub.
	3 +4 +7! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
no
	self blub.! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
partialOnly

	<layer: #l1>! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
partialOnly

	<layer: #l2>! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: ''!
partialOnly
	<layer: #l5>
	self blub.! !

CSMyClass subclass: #CSMyClassSub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: ''!
blub

	"neu in sub"! !

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: ''!
no
! !

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: ''!
partialOnly
	<layer: #l4>
	self huhu.
	super partialOnly.! !

Object subclass: #CSProcessContextInformation
	instanceVariableNames: 'activeLayers methodChain executedPartialMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:00'!
activeLayers
	^ activeLayers ifNil: [ activeLayers := #() ]! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'nw 12/12/2011 17:05'!
activeLayers: layers
	activeLayers := layers! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'nw 12/12/2011 17:06'!
executedPartialMethod
	^ executedPartialMethod! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'nw 12/12/2011 17:06'!
executedPartialMethod: partialMethod
	executedPartialMethod := partialMethod! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'ag 12/18/2011 11:13'!
methodChain
	
	^ methodChain! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'ag 12/18/2011 11:13'!
methodChain: anOrderedCollection
	
	methodChain := anOrderedCollection.! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'ag 12/23/2011 15:48'!
restoreStateFrom: anArray
	"anArray must be the return value of an earlier #saveState call."
	
	self methodChain: anArray first.
	self executedPartialMethod: anArray second.! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'ag 12/23/2011 15:48'!
saveState
	
	^ { self methodChain. self executedPartialMethod }! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'ag 12/20/2011 23:54'!
withLayers: aCollection do: aBlock
	"Convenience method for layer-manipulation. Stores old layers and restores them after executing aBlock."
	
	| oldLayers |
	oldLayers := self activeLayers.
	self activeLayers: aCollection.
	^ aBlock ensure: [ self activeLayers: oldLayers ]! !

Object subclass: #CSTestRenderingInterface
	instanceVariableNames: 'loggedInUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:37:04.448'!
getCanvas
	
	^ Transcript! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:26:33.654'!
logInUser: aUser
	
	loggedInUser := aUser.! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:26:22.283'!
loggedInUser
	
	^ loggedInUser! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:33:04.915'!
logout
	
	loggedInUser := nil.! !

!CSTestRenderingInterface methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:25:48.54'!
showUser: aUser
	
	(self loggedInUser
		ifNil: [ { loggedOutLayer } ]
		ifNotNilDo: [ :loggedInUser |
			loggedInUser isAdmin
				ifTrue: [ { editableLayer } ]
				ifFalse: [ {} ]])
					withLayersDo: [ aUser renderDetails: self getCanvas ].! !

Object subclass: #CSTestUser
	instanceVariableNames: 'username admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSTestUser class methodsFor: 'instance creation' stamp: 'ag 1/27/2012 16:51:21.396'!
named: aString
	
	^ self new username: aString; yourself! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:28:17.724'!
beAdmin
	
	admin := true.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:29:17.02'!
initialize
	
	super initialize.
	admin := false.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:28:10.628'!
isAdmin
	
	^ admin! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:12.59'!
renderDetails: aCanvas
	
	self
		renderProfileIcon: aCanvas;
		renderUsername: aCanvas;
		renderEmail: aCanvas.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:52:28.335'!
renderEditButton: aCanvas
	
	aCanvas cr; show: 'Edit button for user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:29.492'!
renderEmail: aCanvas
	
	aCanvas cr; show: 'Email icon of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:27:28.193'!
renderForbidden: aCanvas
	
	aCanvas cr; show: 'Forbidden to view user ', username, '!!'.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:32:38.278'!
renderProfileIcon: aCanvas
	
	aCanvas cr; show: 'Profile icon of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 2/1/2012 16:29:58.116'!
renderUsername: aCanvas
	
	aCanvas cr; show: 'Username of user ', username.! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:34:40.556'!
username
	
	^ username! !

!CSTestUser methodsFor: 'rendering' stamp: 'ag 1/27/2012 16:34:48.534'!
username: aString
	
	username := aString! !

!Object methodsFor: '*ContextS2' stamp: 'ag 12/23/2011 11:30'!
currentLayer
	"Return the first of the currentLayers for convenience.
	This should be the first activated layer that has lead to the activation of the last partial method."
	
	^ self currentLayers ifNotNilDo: #first! !

!Object methodsFor: '*ContextS2' stamp: 'ag 12/23/2011 11:33'!
currentLayers
	"Return the layers of the current execution. If no method associated to any layer is on the execution stack, nil is returned.
	Else, the last partial method that has started execution determines the 'current layers'.
	These are the layers that have lead to the activation of this partial method (-> the subset of the currently active layers, that intersects with the partial methods layers).
	This returns (sub)instances of CSLayer.
	If a subclass of CSLayer with the right globalLayerName exists, its singleton-instance is used, else an anonymous instance of CSLayer."
	
	| info |
	info := Processor activeProcess csInfo.
	^ info executedPartialMethod
		ifNotNilDo: [ :partialMethod |
			((info activeLayers intersection: partialMethod layers)
				collect: [ :layername | CSLayer layerNamed: layername ])
					ifEmpty: [ nil ] ]! !

!Object methodsFor: '*ContextS2' stamp: 'tfel 2/23/2012 17:05:44.781'!
isContextSMethod

	^ false! !

!Array methodsFor: '*ContextS2' stamp: 'ag 1/27/2012 16:48:52.707'!
withLayersDo: aBlock
	"Memorize currently active layers, add the new ones and restore the state afterwards.
	The layer-name-symbols are extracted from the receiver, in case real CSLayer-object are stored here.
	TODO in future, change internal layer-management to only use real layer-objects."
	
	| layerNames |
	layerNames := self collect: #layerName.
	^ Processor activeProcess csInfo
		withLayers: (Processor activeProcess csInfo activeLayers copyWithoutAll: layerNames), layerNames
		do: aBlock! !

!Array methodsFor: '*ContextS2' stamp: 'ag 12/20/2011 21:31'!
withoutLayersDo: aBlock
	"Memorize currently active layers, remove some and restore the state afterwards."
	
	^ Processor activeProcess csInfo
		withLayers: (Processor activeProcess csInfo activeLayers copyWithoutAll: self)
		do: aBlock! !

MethodReference subclass: #CSMethodReference
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSMethodReference class methodsFor: 'instance creation' stamp: 'tfel 2/23/2012 18:54:11.379'!
onMethod: aMethod

	^ (self class: aMethod methodClass selector: aMethod selector)
		method: aMethod;
		yourself! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 19:06:54.797'!
asMethodDefinition
	"Override, unification happens based on class and selector in MC"
	^ (MCMethodDefinition forMethodReference: self)
		selector: self method asSymbol;
		yourself! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 18:42:27.33'!
compiledMethod

	^ self method! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 2/23/2012 18:40:15.256'!
method
	"Answer the value of method"

	^ method! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 2/23/2012 18:40:15.277'!
method: anObject
	"Set the value of method"

	method := anObject! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 18:55:02.754'!
source

	^ self method getSource asString! !

!CSMethodReference methodsFor: 'packageinfo-base' stamp: 'tfel 2/23/2012 18:55:09.204'!
sourceCode

	^ self source asString! !

!Symbol methodsFor: '*ContextS2' stamp: 'ag 1/22/2012 14:51:21.558'!
asLayer
	"Return the first-class layer-object with the name represented by the receiver."
	
	^ CSLayer layerNamed: self! !

!Symbol methodsFor: '*ContextS2' stamp: 'ag 1/22/2012 14:52:50.783'!
layerName
	"Also implemented on CSLayer, to transparently access the layer-name of a layer-object without knowing whether it actually is the object or the name-symbol already."
	
	^ self! !

!Symbol methodsFor: '*ContextS2' stamp: 'ag 12/22/2011 15:26'!
withLayerDo: aBlock
	
	^ (Array with: self) withLayersDo: aBlock! !

!Symbol methodsFor: '*ContextS2' stamp: 'ag 12/22/2011 15:26'!
withoutLayerDo: aBlock
	
	^ (Array with: self) withoutLayersDo: aBlock! !

TestCase subclass: #CSGeneralTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

CSGeneralTestCase subclass: #CSBehavioralVariationsTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a
	"Answer the value of a"

	^ a! !

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a: anObject
	"Set the value of a"

	a := anObject! !

!CSBehavioralVariationsTest methodsFor: 'running' stamp: 'ag 12/21/2011 20:58'!
layers: someLayers shouldResultIn: anArrayOfSymbols
	
	someLayers withLayersDo: [ self a myMethod ].
	self assert: self a executedMethods size = anArrayOfSymbols size.
	self assert: self a executedMethodsArray = anArrayOfSymbols.! !

!CSBehavioralVariationsTest methodsFor: 'running' stamp: 'mpe 11/7/2010 18:30'!
setUp

	self a: CSClassA new.! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 1/27/2012 17:31:58.672'!
test01ExecuteBaseMethod
	
	self
		layers: #()
		shouldResultIn: #(base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:05'!
test02ExecuteBeforeBaseMethod
	
	self
		layers: #(before)
		shouldResultIn: #(before base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 1/30/2012 11:44:02.336'!
test04aExecuteBeforeBaseAfterMethod
	
	self
		layers: #(before after)
		shouldResultIn: #(before base after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test04bExecuteBeforeBaseAfterMethod
	
	self
		layers: #(after before)
		shouldResultIn: #(before base after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test05ExecuteAroundMethod
	
	self
		layers: #(replace)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:06'!
test06ExecuteAroundProceedBaseMethod
	
	self
		layers: #(proceed1)
		shouldResultIn: #(proceed1before base proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:07'!
test07aExecuteAroundProceedAroundMethod
	
	self
		layers: #(proceed1 replace)
		shouldResultIn: #(proceed1before replace proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:40'!
test07bExecuteAroundProceedAroundMethod
	
	self
		layers: #(replace proceed1)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:07'!
test08ExecuteBeforeAroundAfterMethod
	
	self
		layers: #(before replace after)
		shouldResultIn: #(before replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:57'!
test09ExecuteBeforeAroundProceedBaseAfterMethod
	
	self
		layers: #(before proceed1 after)
		shouldResultIn: #(before proceed1before base after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:42'!
test09aExecuteBeforeAroundProceedBaseAfterMethod
	
	self
		layers: #(proceed1 before after)
		shouldResultIn: #(proceed1before before base after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:11'!
test10ExecuteBeforeAroundProceedAroundAfterMethod
	
	self
		layers: #(before replace proceed1 after)
		shouldResultIn: #(before replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:11'!
test10aExecuteBeforeAroundProceedAroundAfterMethod
	
	self
		layers: #(after before replace proceed1)
		shouldResultIn: #(before replace after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:57'!
test11aReturnValueFromAround
	
	#replacedReturn withLayerDo: [ self assert: self a myReturnMethod = #replacedReturn ].! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 12:01'!
test11bReturnValueFromBase
	
	self assert: self a myReturnMethod = #base.! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:13'!
test12MultipleChainedProceeds
	
	self
		layers: #(proceed1 proceed2)
		shouldResultIn: #(proceed1before proceed2before base proceed2after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 20:58'!
test13MultipleChainedProceedsWithoutBase
	
	self
		layers: #(proceed1 proceed2 replace)
		shouldResultIn: #(proceed1before proceed2before replace proceed2after proceed1after).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/21/2011 16:14'!
test13aMultipleChainedProceedsWithoutBase
	
	self
		layers: #(replace proceed1 proceed2)
		shouldResultIn: #(replace).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'ag 12/23/2011 16:57'!
test14MultiArgumentProceed
	
	#(someLayer someLayer2) withLayersDo: [ self assert: 19 = (CSClassA new myMethod: 12 and: 5) ].! !

CSGeneralTestCase subclass: #CSContextSTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

CSContextSTest subclass: #CSAddingMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
addMethodFrom: code
	
	self addMethodFrom: code toClass: CSClassA.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
test01AddCompiledMethodExistingNil
	
	self addMethodFrom: self baseCode.
	self assert: self generatedMethod class == CompiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:55'!
test02AddCompiledMethodExistingCompiledMethod
	
	| compiledMethod |
	self addMethodFrom: self baseCode.
	compiledMethod := self generatedMethod.
	self addMethodFrom: self baseCode.
	self deny: self generatedMethod == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:57'!
test03aAddCompiledMethodExistingLayeredMethodWithoutBase
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self deny: layeredMethod includesBaseMethod.
	self assert: layeredMethod baseMethod isNil.
	
	self addMethodFrom: self baseCode.
	self assert: layeredMethod includesBaseMethod.
	self assert: layeredMethod partialMethods size == 1.
	self assert: layeredMethod partialMethods first class == CSPartialMethod.
	self assert: layeredMethod baseMethod class == CompiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 12:04'!
test03bAddCompiledMethodExistingLayeredMethodWithBase
	
	| layeredMethod oldBaseMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldBaseMethod := layeredMethod baseMethod.
	
	self addMethodFrom: self baseCode.
	self assert: layeredMethod partialMethods size = 1.
	self deny: layeredMethod baseMethod == oldBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/22/2011 11:58'!
test04AddPartialMethodExistingNil
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod class == CSLayeredMethod.
	self deny: layeredMethod includesBaseMethod.
	self assert: layeredMethod partialMethods size = 1.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 09:57:13.749'!
test05AddPartialMethodExistingCompiledMethod
	
	| compiledMethod layeredMethod |
	self addMethodFrom: self baseCode.
	compiledMethod := self generatedMethod.
	self assert: compiledMethod class == CompiledMethod.
	
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod class == CSLayeredMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod basePartialMethod method == compiledMethod.
	self assert: layeredMethod partialMethods first class == CSPartialMethod.
	self assert: layeredMethod baseMethod == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 10:23:24.443'!
test06aAddPartialMethodExistingLayeredMethodLayerNoCombinationNotExistingWithBase
	
	| layeredMethod oldPartial |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self assert: layeredMethod includesBaseMethod.
	oldPartial := layeredMethod partialMethods first.
	
	[self addMethodFrom: self threeLayersCode] valueSupplyingAnswer: true.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self assert: layeredMethod partialMethods first ~= oldPartial.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'tfel 2/29/2012 10:23:03.368'!
test06bAddPartialMethodExistingLayeredMethodLayerNoCombinationNotExistingWithoutBase
	
	| layeredMethod |
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self deny: layeredMethod includesBaseMethod.
	
	[self addMethodFrom: self threeLayersCode] valueSupplyingAnswer: true.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self deny: layeredMethod includesBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test06cAddPartialMethodExistingLayeredMethodLayerCombinationExistingSingle
	
	| layeredMethod oldPartialMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self singleLayerCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldPartialMethod := layeredMethod partialMethods first.
	
	self addMethodFrom: self singleLayerCode.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1).
	self deny: layeredMethod partialMethods first == oldPartialMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test06dAddPartialMethodExistingLayeredMethodLayerCombinationExistingMultiple
	
	| layeredMethod  oldBaseMethod oldPartialMethod |
	self addMethodFrom: self baseCode.
	self addMethodFrom: self threeLayersCode.
	layeredMethod := self generatedMethod.
	self assert: layeredMethod partialMethods size = 1.
	oldPartialMethod := layeredMethod partialMethods first.
	oldBaseMethod := layeredMethod baseMethod.
	
	self addMethodFrom: self threeLayersCode.
	self assert: layeredMethod partialMethods size = 1.
	self assert: layeredMethod partialMethods first layers = #(l1 l2 l3).
	self deny: layeredMethod partialMethods first == oldPartialMethod.
	self assert: layeredMethod baseMethod == oldBaseMethod.
	oldPartialMethod := layeredMethod partialMethods first.
	
	self addMethodFrom: self baseCode.
	self deny: layeredMethod baseMethod == oldBaseMethod.
	self assert: layeredMethod partialMethods first == oldPartialMethod.! !

CSContextSTest subclass: #CSCompilerExtensionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/22/2011 13:43'!
compile: aSourceCodeString
	"This does not add the method to the class."
	
	| method |
	method := (CSClassA
		compile: aSourceCodeString
		classified: 'generated partial methods'
		notifying: nil
		trailer: CompiledMethodTrailer empty
		ifFail: nil	) method.
	self deny: (CSClassA methodDict includes: self generatedSelector).
	^ method! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/22/2011 13:44'!
test01CompileBaseMethod
	
	self assert: (self compile: self baseCode) class = CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 1/27/2012 17:15:30.036'!
test02CompileBaseMethodAsPartialMethod
	
	| method |
	method := (self compile: self baseCode) asPartialMethod.
	self assert: method class = CSPartialMethod.
	self assert: method layers isEmpty.
	self assert: method isBase.
	self assert: method method class == CompiledMethod.
	self assert: method method = (self compile: self baseCode).! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test03aCompileMultipleLayers
	
	| method |
	method := self compile: self singleLayerCode.
	self assert: method class = CSPartialMethod.
	self assert: method layers = #(l1).
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test03bCompileMultipleLayers
	
	| method |
	method := self compile: self threeLayersCode.
	self assert: method class = CSPartialMethod.
	self assert: method layers = #(l1 l2 l3).
	self assert: method method class == CompiledMethod.! !

!CSContextSTest class methodsFor: 'constants' stamp: 'ag 12/21/2011 21:35'!
generatedSelector

	^ #generatedPartialMethod! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 12/22/2011 11:53'!
addMethodFrom: aSourceCodeString toClass: aClass
	
	aClass
		compile: aSourceCodeString
		classified: 'partial methods generated during tests'
		withStamp: Utilities changeStamp
		notifying: nil.
	self assert: (aClass methodDict includesKey: self generatedSelector).! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/21/2011 21:40'!
baseCode
	
	^ self codeForLayers: nil! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:47'!
codeForLayers: layerSymbols
	"Method code contains only"
	
	^ self codeForLayers: layerSymbols withContent: ''! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:47'!
codeForLayers: layerSymbols withContent: contentString
	"Method code contains only"
	
	^ (self generatedSelector, 
		'\"This method has been generated by ', self class name, 
		' and may be deleted."\',
		(layerSymbols ifNil: [ '' ] ifNotNil: [ '<layer: ', layerSymbols printString, '>' ]),
		contentString)
			withCRs! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 12/22/2011 11:42'!
deleteMethod
	
	CSClassA removeSelector: self generatedSelector.! !

!CSContextSTest methodsFor: 'accessing' stamp: 'ag 12/22/2011 11:54'!
generatedMethod
	
	^ CSClassA >> self generatedSelector! !

!CSContextSTest methodsFor: 'accessing' stamp: 'ag 12/21/2011 21:35'!
generatedSelector

	^ self class generatedSelector! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 12/22/2011 11:42'!
setUp
	
	self
		deleteMethod;
		deny: (CSClassA methodDict includesKey: self generatedSelector).! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:51'!
singleLayerCode
	
	^ self codeForLayers: #l1! !

!CSContextSTest methodsFor: 'running' stamp: 'ag 1/27/2012 17:19:43.173'!
tearDown
	
	self deleteMethod.
	super tearDown.! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:51'!
threeLayersCode
	
	^ self codeForLayers: #(l1 l2 l3)! !

!CSContextSTest methodsFor: 'method code' stamp: 'ag 12/22/2011 11:52'!
twoLayersCode
	
	^ self codeForLayers: #(l1 l2)! !

CSContextSTest subclass: #CSPartialMethodTest
	instanceVariableNames: 'partialMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:50'!
deleteMethod
	
	super deleteMethod.
	CSClassB removeSelector: self generatedSelector.
	CSSubclassB removeSelector: self generatedSelector.! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:48'!
partialCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ count + 1'! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:59'!
partialMethodFrom: aClass
	
	^ (aClass >> self generatedSelector) partialMethods first! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:49'!
partialSubCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ super generatedPartialMethod + count'! !

!CSPartialMethodTest methodsFor: 'method code' stamp: 'ag 12/22/2011 13:49'!
partialSubSuperCountMethod
	
	^ self codeForLayers: #l1 withContent: '^ super count'! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'ag 12/22/2011 13:50'!
setUp
	
	super setUp.
	self addMethodFrom: self partialCountMethod toClass: CSClassB.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/23/2011 11:31'!
test01CompilePartialMethodAndToClass
	
	| partialMethod |
	partialMethod := self partialMethodFrom: CSClassB.
	self assert: partialMethod layers = #(l1).
	self assert: partialMethod method class == CompiledMethod.
	self assert: partialMethod method selector == self generatedSelector.
	self assert: partialMethod method methodClass == CSClassB.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 13:58'!
test02aCallPartialMethod
	
	self assert: ((self partialMethodFrom: CSClassB) valueWithReceiver: CSClassB new arguments: #()) = 2.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:04'!
test02bCallPartialMethodFromInstance
	
	#l1 withLayerDo: [ self assert: CSClassB new generatedPartialMethod = 2 ].! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:00'!
test03CallPartialMethodWithSuperCall
	
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 3.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:05'!
test03aCallPartialMethodWithSuperCall
	
	self addMethodFrom: self partialSubCountMethod toClass: CSSubclassB.
	#l1 withLayerDo: [ self assert: CSSubclassB new generatedPartialMethod = 3 ].! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:05'!
test04CallPartialMethodWithSuperCallToStandardMethod
	
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubSuperCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 1.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:00'!
test05CallPartialMethodFromSubclass

	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self assert: CSSubclassB new generatedPartialMethod = 2.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'ag 12/22/2011 14:06'!
test05aCallPartialMethodFromSubclass
	
	#l1 withLayerDo: [ self assert: CSSubclassB new generatedPartialMethod = 2 ].! !

!CSGeneralTestCase methodsFor: 'running' stamp: 'ag 1/31/2012 15:37:35.213'!
checkConsistencyEachTest
	
	^ false! !

!CSGeneralTestCase methodsFor: 'running' stamp: 'ag 1/31/2012 15:38:40.644'!
tearDown
	"This throws an assertion-error, if one of the method-instances becomes inconsistent."
	
	self checkConsistencyEachTest ifTrue: [
		[ CSMethodObject checkAllInstances ]
			on: Exception do: [ :e |
				Transcript cr; show: 'Inconsistency after test (in ', self class name , '): ', e, '. Trying to fix inconsistency.'.
				CSMethodObject fixAllInstances ] ].! !

CSGeneralTestCase subclass: #CSLayerInstancesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSLayerInstancesTest methodsFor: 'constants' stamp: 'ag 12/22/2011 17:14'!
layerName
	
	^ #testlayer! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test1NoCurrentLayer
	
	self assert: self currentLayers isNil.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test2NestedLayersNoCurrentLayer
	
	#a withLayerDo: [
		#b withLayerDo: [
			self assert: self currentLayers isNil ] ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:34'!
test3SingleLayerNoCurrentLayer
	
	#a withLayerDo: [ self assert: self currentLayers isNil ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 1/30/2012 13:12:23.986'!
test4CurrentLayerWithoutPartialMethod
	
	#zzz withLayerDo: [ self assert: CSClassA new getCurrentLayerA isNil ].! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test5CurrentLayerSingleLayer
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerA ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:39'!
test5aCurrentLayerSingleLayer
	
	| layer |
	#(b a) withLayersDo: [ layer := CSClassA new getCurrentLayerA ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test6CurrentLayerSingleLayerTwoLayerMethod
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:36'!
test7CurrentLayerSingleLayerTwoLayerMethod2
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:37'!
test8CurrentLayerMultipleLayersTwoLayerMethod
	
	| layer |
	#(a b) withLayersDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) = #(a b).! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:38'!
test9CurrentLayerMultipleLayersTwoLayerMethod2
	
	| layer |
	#(a b) withLayersDo: [ layer := CSClassA new getCurrentLayerBA ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) = #(a b).! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testAnonymousLayerInstance
	
	| instance |
	CSLayer layerNamed: self layerName.
	self assert: (Smalltalk includesKey: self layerName).
	CSLayer resetLayer: self layerName.
	self assert: (Smalltalk includesKey: self layerName) not.
	instance := CSLayer layerNamed: self layerName.
	self assert: (Smalltalk at: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:20'!
testAnonymousLayerInstanceReplaced
	
	| instance |
	CSLayer resetLayer: self layerName.
	instance := CSLayer layerNamed: self layerName.
	CSLayer resetLayer: self layerName.
	self deny: (CSLayer layerNamed: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:21'!
testAnonymousLayerInstanceSame
	
	| instance |
	CSLayer resetLayer: self layerName.
	instance := CSLayer layerNamed: self layerName.
	self assert: (CSLayer layerNamed: self layerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testSubclassedLayerInstance
	"This tests 2 things: #resetInstance (removes the global variable) and #instance (creates it and adds it as global variable)"
	
	| instance |
	CSTestLayer instance.
	self assert: (Smalltalk includesKey: CSTestLayer globalLayerName).
	CSTestLayer resetInstance.
	self assert: (Smalltalk includesKey: CSTestLayer globalLayerName) not.
	instance := CSTestLayer instance.
	self assert: (Smalltalk at: CSTestLayer globalLayerName) == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/23/2011 12:00'!
testSubclassedLayerInstanceAccessableWithLayerNamed
	
	| instance |
	instance := CSTestLayer instance.
	self assert: instance == (CSLayer layerNamed: CSTestLayer globalLayerName).
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	self assert: instance == (CSLayer layerNamed: CSTestLayer globalLayerName).! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:22'!
testSubclassedLayerInstanceReplaced
	
	| instance |
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	CSTestLayer resetInstance.
	self deny: CSTestLayer instance == instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/23/2011 13:53'!
testSubclassedLayerInstanceResettableWithLayerNamed
	
	| instance |
	instance := CSTestLayer instance.
	CSLayer resetLayer: CSTestLayer globalLayerName.
	self deny: instance == CSTestLayer instance.! !

!CSLayerInstancesTest methodsFor: 'testing' stamp: 'ag 12/22/2011 17:21'!
testSubclassedLayerInstanceSame
	
	| instance |
	CSTestLayer resetInstance.
	instance := CSTestLayer instance.
	self assert: CSTestLayer instance == instance.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:40'!
testz10CurrentLayerMultipleLayersTwoLayerMethod3
	
	| layer |
	#(b a) withLayersDo: [ layer := CSClassA new getCurrentLayerAB ].
	self assert: layer notNil.
	self assert: layer size == 2.
	self assert: (layer collect: #layerName) = #(b a).! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:44'!
testz11CurrentLayerNestedCalls
	"First partial method on layer #b is run, and inside another partial method on layer #a."
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #a ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:47'!
testz12CurrentLayerNestedCalls2
	"Current Layer not changed when another partial method is invoked in its base version."
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls3
	
	| layer |
	#a withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #a.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls4
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerAB on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

!CSLayerInstancesTest methodsFor: 'testing-current-layer' stamp: 'ag 12/23/2011 11:48'!
testz12CurrentLayerNestedCalls5
	
	| layer |
	#b withLayerDo: [ layer := CSClassA new getCurrentLayerOf: #getCurrentLayerBA on: #zzz ].
	self assert: layer notNil.
	self assert: layer size == 1.
	self assert: layer first layerName == #b.! !

CSGeneralTestCase subclass: #CSLayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSLayerTest methodsFor: 'accessing' stamp: 'ag 12/17/2011 21:52'!
activeLayers

	^ self process csInfo activeLayers! !

!CSLayerTest methodsFor: 'accessing' stamp: 'mp 6/11/2010 20:54'!
process
	^ Processor activeProcess! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:50'!
test01LayerCollectionInitialization

	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:50'!
test02aSingleLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test02bSingleLayerActivation
	#(l1) withLayersDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/21/2011 11:50'!
test03ComplicatedNestedLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		#(l1 l2 l3) withLayersDo: [
			self assert: self activeLayers size = 3.
			self assert: self activeLayers first = #l1.
			self assert: self activeLayers last = #l3.
			#l1 withoutLayerDo: [
				self assert: self activeLayers size = 2.
				self assert: self activeLayers first = #l2.
				self assert: self activeLayers last = #l3.
				].
			self assert: self activeLayers size = 3.
			self assert: self activeLayers first = #l1.
			self assert: self activeLayers last = #l3.
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = 'l1'.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test03NestedLayerActivation
	#l1 withLayerDo: [
		self assert: self activeLayers notEmpty.
		self assert: self activeLayers first = #l1.
		#l1 withLayerDo: [
			self assert: self activeLayers size = 1.
			self assert: self activeLayers first = #l1.
			#l1 withLayerDo: [
				self assert: self activeLayers size = 1.
				self assert: self activeLayers first = #l1.
				]
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = 'l1'.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test04LayerDeactivation
	#l1 withLayerDo: [
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = #l1.
		#l1 withoutLayerDo: [
			self assert: self activeLayers isEmpty.
			].
		self assert: self activeLayers size = 1.
		self assert: self activeLayers first = #l1.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test05MultipleLayerDeactivation
	#(l1 l2 l3) withLayersDo: [
		self assert: self activeLayers size = 3.
		self assert: self activeLayers last = #l3.
		#l2 withoutLayerDo: [
			self assert: self activeLayers size = 2.
			self assert: self activeLayers last = #l3.
			self assert: self activeLayers first = #l1].
		self assert: self activeLayers size = 3.
		self assert: self activeLayers second = #l2.
		#(l1 l2) withoutLayersDo: [
			#l3 withoutLayerDo: [self assert: self activeLayers isEmpty].
			self assert: self activeLayers first = #l3].
		self assert: self activeLayers size = 3.
		].
	self assert: self activeLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'ag 12/17/2011 21:51'!
test06LayerDeactivationInNonLocalReturns
	self assert: self activeLayers isEmpty.
	self deny: CSClassA new nonLocalReturn.
	self assert: self activeLayers isEmpty.! !

CSGeneralTestCase subclass: #CSzzzConsistencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSzzzConsistencyTest methodsFor: 'testing' stamp: 'ag 1/31/2012 15:37:20.579'!
testConsistency
	"The message-send in this test throws an AssertionError, if the consistency of the ContextS-classes and objects is broken.
	This test is executed once after all the other tests, therefore the classname with the 'zzz'-part.
	If this test fails, it seems there is a bug somewhere. You can (try to) restore system-consistency with the following DoIt:"
	"CSMethodObject fixAllInstances"
	
	CSMethodObject checkAllInstances.! !

Browser subclass: #CSBrowser
	instanceVariableNames: 'selectedLayerSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:14.747'!
allLayersMarker
	
	^ #'-- all --'! !

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:09.869'!
baseMethodsMarker
	
	^ #'-- base methods --'! !

!CSBrowser class methodsFor: 'class initialization' stamp: 'tfel 2/23/2012 18:15:51.225'!
initialize

	super initialize.
	TheWorldMenu registerOpenCommand: {'ContextS Browser'. {self. #open}}.! !

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:04.976'!
nonLayeredMarker
	
	^ #'-- non-layered --'! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/27/2012 18:39:22.284'!
allLayersAndMethodsFrom: aList

	^ Array streamContents: [:stream |
		aList do: [:method |
			method isContextSMethod
					ifTrue: [
						method basePartialMethod ifNotNilDo: [:m | stream nextPut: m].
						stream nextPutAll: method partialMethods]
					ifFalse: [stream nextPut: method]]]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/27/2012 18:38:48.296'!
baseMethodsFrom: aList

	^ (aList
		select: [:method | method isContextSMethod]
		thenCollect: [:method | method basePartialMethod])
		reject: [:method | method isNil]! !

!CSBrowser methodsFor: 'Tools' stamp: 'tfel 2/28/2012 16:06:36.843'!
browseVersions

	^ [super browseVersions]
		on: Error
		do: [:e | self inform: 'Sorry. Only actual methods can show versions'].! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 16:02:42.692'!
buildContextLayerListWith: builder
	
	^ builder pluggableListSpec new
		model: self;
		list: #contextLayerList;
		getIndex: #selectedLayerIndex;
		setIndex: #selectedLayerIndex:;
		menu: #contextLayerMenu:;
		keyPress: #arrowKey:from:;
		yourself! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 17:56:37.637'!
buildWindowWith: builder specs: aSpecList
	| paneSpecs codeSpec slimPaneSpecs layerPaneSpec layerPaneFrame |
	paneSpecs := aSpecList first: 5.
	codeSpec := aSpecList last.
	slimPaneSpecs := self compressWidthOfSpecs: paneSpecs from: 1/4 to: 1/5.
	layerPaneFrame := slimPaneSpecs first key copy
							leftFraction: 0.8;
							rightFraction: 1;
							yourself.
	layerPaneSpec := layerPaneFrame -> [self buildContextLayerListWith: builder].
	self when: #classSelectionChanged send: #resetLayers to: self.
	^ super
		buildWindowWith: builder
		specs: slimPaneSpecs, {layerPaneSpec}, {codeSpec}! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 16:46:17.613'!
compressWidthOfSpecs: specs from: aFraction to: anotherFraction

	^ specs collect: [:assoc || frame |
		frame := assoc key isRectangle
					ifTrue: [LayoutFrame fractions: assoc key] ifFalse: [assoc key].
		frame rightFraction: frame rightFraction / aFraction * anotherFraction.
		frame leftFraction: frame leftFraction / aFraction * anotherFraction.
		frame -> assoc value].
! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:04:58.234'!
contextLayerList
	
	^ self selectedClassOrMetaClass
		ifNil: [#()]
		ifNotNilDo: [:class |
			{ self class allLayersMarker.
			self class nonLayeredMarker.
			self class baseMethodsMarker },
			self selectedClassOrMetaClass allInvolvedLayers asArray ]! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 18:01:34.413'!
contextLayerMenu: aMenu
	
	(self menuHook: aMenu named: #messageCategoryMenu shifted: false).
	^ aMenu
		labels: 'delete layer'
		lines: #()
		selections: #(deleteSelectedLayer)! !

!CSBrowser methodsFor: 'initialize-release' stamp: 'tfel 2/23/2012 16:16:16.924'!
defaultBrowserTitle
	
	^ 'Context Browser'! !

!CSBrowser methodsFor: 'layer functions' stamp: 'tfel 2/23/2012 18:05:09.168'!
deleteSelectedLayer

	self inform: 'Not implemented'.! !

!CSBrowser methodsFor: 'user interface' stamp: 'tfel 2/28/2012 10:31:38.455'!
initialExtent
	| baseExtent |
	baseExtent := super initialExtent.
	^ (baseExtent x / 4 * 5)@(baseExtent y)! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:46:28.392'!
messageList
	
	^ self messageObjectsList collect: #asSymbol! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:41:37.844'!
messageObjectsList
	| list |
	list := super messageList collect: [:selector |
					self selectedClassOrMetaClass >> selector].
	^ self selectedLayerSymbol
		caseOf: {[self class nonLayeredMarker] -> [self nonLayeredMessagesFrom: list].
	 				[self class allLayersMarker] -> [self allLayersAndMethodsFrom: list].
	 				[self class baseMethodsMarker] -> [self baseMethodsFrom: list]}
		otherwise: [self messagesInLayer: self selectedLayerSymbol from: list]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:42:34.234'!
messagesInLayer: aSymbol from: aList

	^ (Array streamContents: [:stream | (aList
		select: [:method | method isContextSMethod]
		thenCollect: [:method | stream nextPutAll: method partialMethods])])
		select: [:method | method layers includes: self selectedLayerSymbol]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:45:25.34'!
nonLayeredMessagesFrom: aList

	^ aList select: [:method | method isContextSMethod not]! !

!CSBrowser methodsFor: 'message functions' stamp: 'tfel 2/23/2012 18:11:46.858'!
removeMessage
	"Changed to delete only one partial method for ContextS methods."
	| method confirmation |
	self messageListIndex = 0 | self okToChange not ifTrue: [^ self].
	method := self messageObjectsList at: self messageListIndex.
	method isContextSMethod ifFalse: [^ super removeMessage].

	confirmation := self systemNavigation 
							confirmRemovalOf: method selector
							on: self selectedClassOrMetaClass.
	confirmation = 3 ifTrue: [^ self].
	
	(self selectedClassOrMetaClass >> method selector) removePartialMethod: method.
	self changed: #messageList.
	self messageListIndex: 0.
	
	self setClassOrganizer.
	"In case organization not cached"
	confirmation = 2 ifTrue: [self systemNavigation browseAllCallsOn: method selector].! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 17:57:30.108'!
resetLayers
	
	self selectedLayerIndex: 0.  ! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:07:53.324'!
selectedLayerIndex
	
	^ self contextLayerList indexOf: self selectedLayerSymbol! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:50:10.884'!
selectedLayerIndex: anInteger
	
	self selectedLayerSymbol: (self contextLayerList at: anInteger ifAbsent: []).
	self
		changed: #selectedLayerIndex;
		changed: #contextLayerList;
		changed: #messageCategoryList;
		changed: #relabel;
		contentsChanged;
		messageCategoryListIndex: 1. "Select the --all-- category, deselect messages."! !

!CSBrowser methodsFor: 'accessing' stamp: 'tfel 2/23/2012 16:06:26.772'!
selectedLayerSymbol
	"This returns the name of the layer (as symbol), not the layer object."
	
	^ selectedLayerSymbol ifNil: [selectedLayerSymbol := self class allLayersMarker]! !

!CSBrowser methodsFor: 'accessing' stamp: 'tfel 2/23/2012 16:07:40.398'!
selectedLayerSymbol: anObject
	"Set the value of selectedLayerSymbol"

	selectedLayerSymbol := anObject! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:49:01.638'!
selectedMessage

	^ (super selectedMessage isEmpty and: [self messageListIndex = 0])
		ifTrue: [^ '']
		ifFalse: [(self messageObjectsList at: self messageListIndex) getSource]
! !

Browser subclass: #CSContextBrowser
	instanceVariableNames: 'selectedLayerIndex contextLayerList messageCategoryList messageList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/22/2012 15:22:53.043'!
allLayersMarker
	
	^ #'-- all --'! !

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/20/2012 22:16:40.498'!
baseMethodsMarker
	
	^ #'-- base methods --'! !

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/22/2012 10:34:34.381'!
nonLayeredMarker
	
	^ #'-- non-layered --'! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 18:20:57.702'!
buildContextLayerListWith: builder
	
	^ builder pluggableListSpec new
		model: self;
		list: #contextLayerList;
		getIndex: #selectedLayerIndex;
		setIndex: #selectedLayerIndex:;
		menu: #contextLayerMenu:;
		keyPress: #arrowKey:from:;
		yourself! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:43:05.903'!
buildMessageCategoryBrowserEditString: aString
	"Copied from superclass, changed to integrate with other functionality of this class (Correctly select the index of the selected message category)."

	"Create and schedule a message category browser for the currently 
	selected	 message category. The initial text view contains the characters 
	in aString."
	"wod 6/24/1998: set newBrowser classListIndex so that it works whether the
	receiver is a standard or a Hierarchy Browser."

	| newBrowser |
	self messageCategoryListIndex ~= 0
		ifTrue: 
			[newBrowser := Browser new.
			newBrowser metaClassIndicated: metaClassIndicated.			
			newBrowser systemCategoryListIndex: (newBrowser systemCategoryList indexOf: self selectedSystemCategoryName).
			newBrowser classListIndex: (newBrowser classList indexOf: self selectedClassName).
			newBrowser messageCategoryListIndex: (newBrowser messageCategoryList indexOf: self selectedMessageCategoryName).
			self selectedMessageName ifNotNil: [
				newBrowser messageListIndex: (newBrowser messageList indexOf: self selectedMessageName) ].

			self class openBrowserView: (newBrowser openMessageCatEditString: aString)
				label: 'Message Category Browser (' , 
						newBrowser selectedClassOrMetaClassName , ')']! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 23:00:51.057'!
changed: aSymbol
	"TODO maybe this is not the right way to get the changed-event of the reicever itself..."
	
	aSymbol caseOf: {
		[ #messageList ] -> [ messageList := nil ].
		[ #messageCategoryList ] -> [ messageCategoryList := nil ].
		[ #contextLayerList ] -> [ contextLayerList := nil ].
	} otherwise: [].
	super changed: aSymbol.! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:43:29.32'!
classListIndex: aNumber
	
	selectedLayerIndex := 0. "Set the variable first, do all the real updates after the super-call."
	self messageCategoryListIndex: 0.
	super classListIndex: aNumber.
	self selectedLayerIndex: 0.! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/31/2012 15:29:58.83'!
completeMessageList
	
	| messages |
	messages := SortedCollection sortBlock: [ :mt1 :mt2 |
		(mt1 isSymbol ifTrue: [ mt1 ] ifFalse: [ mt1 selector ]) <= (mt2 isSymbol ifTrue: [ mt2 ] ifFalse: [ mt2 selector ]) ].
	(self selectedClassOrMetaClass ifNil: [ ^ #() ]) methodDict
		valuesDo: [ :method |
			method selector ifNotEmpty: [
				(method isKindOf: CSLayeredMethod)
					ifTrue: [ messages addAll: method allPartialMethods ]
					ifFalse: [ messages add: method selector ] ] ].
	^ messages! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'tfel 2/23/2012 14:41:46.439'!
contextLayerList
	
	^ contextLayerList ifNil: [
		contextLayerList := self classListIndex = 0
			ifTrue: [ Array new ] "No class selected"
			ifFalse: [ 
				{ self class allLayersMarker. self class nonLayeredMarker. self class baseMethodsMarker },
				self selectedClassOrMetaClass allInvolvedLayers asArray ] ]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 18:25:48.119'!
contextLayerMenu: aMenu
	
	(self menuHook: aMenu named: #messageCategoryMenu shifted: false) ifTrue: [ ^ aMenu ].
	^ aMenu
		labels: 'delete layer'
		lines: #()
		selections: #(deleteSelectedLayer)! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/12/2012 12:06'!
defaultBrowserTitle
	
	^ 'Context Browser'! !

!CSContextBrowser methodsFor: 'ui-actions' stamp: 'ag 1/20/2012 21:42:35.885'!
deleteSelectedLayer
	"When the layer is deleted, we delete all partial methods on it.
	If the partial method was the last one in its LayeredMethod, we delete the LayeredMethod <??>"
	
	self selectedLayer delete.
	self selectedLayerIndex: 0.! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 15:32:27.19'!
initialize
	
	super initialize.
	selectedLayerIndex := 0.! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/31/2012 23:05:22.837'!
messageCategoryList
	
	^ messageCategoryList ifNil: [
		messageCategoryList := SortedCollection with: ClassOrganizer allCategory.
		(self selectedClassOrMetaClass ifNil: [ ^ #() ]) methodDict keysAndValuesDo: [ :key :value |
			(self selectedLayer = self class allLayersMarker
			or: [
			(self selectedLayer = self class nonLayeredMarker)
				ifTrue: [ value class ~= CSLayeredMethod ]
				ifFalse: [
					value class == CSLayeredMethod and: [
						(self selectedLayer = self class baseMethodsMarker
							ifTrue: [ value hasBaseMethod ]
							ifFalse: [ value allInvolvedLayers includes: self selectedLayer ]) ] ] ]
			) ifTrue: [
				(self classOrMetaClassOrganizer categoryOfElement: key)
					ifNotNilDo: [ :category | messageCategoryList addIfNotPresent: category ] ] ].
		messageCategoryList ]! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/31/2012 22:54:34.758'!
messageList
	"Select those (partial) methods, that match both the selected category and selected layer."
	
	^ messageList ifNil: [
		messageList := self completeMessageList select: [ :method |
			"First filter the category"
			(self selectedMessageCategoryName isNil
				or: [ self selectedMessageCategoryName = ClassOrganizer allCategory ]
				or: [ (self classOrMetaClassOrganizer categoryOfElement: method asSymbol) = self selectedMessageCategoryName ])
			and: [
			
			"Then the layer"
			self selectedLayer = self class allLayersMarker
			or: [
			(self selectedLayer = self class nonLayeredMarker)
				ifTrue: [ (method isKindOf: CSMethodObject) not ]
				ifFalse: [
					(method isKindOf: CSMethodObject) and: [
						(self selectedLayer = self class baseMethodsMarker)
							ifTrue: [ method isBase ]
							ifFalse: [ method layers includes: self selectedLayer ] ] ] ] ] ] ]! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 15:33:37.095'!
metaClassIndicated: aBool
	"This value is set when one of the instance/class buttons is clicked."
	
	selectedLayerIndex := 0.
	super metaClassIndicated: aBool.
	self changed: #contextLayerList.! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/22/2012 18:09:56.262'!
openEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	"CSContextBrowser fullOnClass: Browser"
	
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue: [ 0.42 ] ifFalse: [ 0.5 ].
	^ self buildWindowWith: builder specs: {
		(0@0 corner: 0.2@max) -> [self buildSystemCategoryListWith: builder].
		(0.2@0 corner: 0.4@(max-0.08)) -> [self buildClassListWith: builder].
		(0.2@(max-0.08) corner: 0.4@max) -> [self buildSwitchesWith: builder].
		(0.6@0 corner: 0.8@max) -> [ self buildMessageCategoryListWith: builder ].
		(0.4@0 corner: 0.6@max) -> [self buildContextLayerListWith: builder].
		(0.8@0 corner: 1@max) -> [self buildMessageListWith: builder].
		(0@max corner: 1@1) -> [self buildCodePaneWith: builder]
	}! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'tfel 2/23/2012 14:44:06.225'!
removeMessage
	"Copied from super-class, changed to delete only one partial method."
	
	| method confirmation |
	self messageListIndex = 0 | self okToChange not ifTrue: [^ self].
	method := self selectedMethod.
	method isSymbol ifTrue: [ ^ super removeMessage ].
	confirmation := self systemNavigation confirmRemovalOf: method selector on: self selectedClassOrMetaClass.
	confirmation = 3 ifTrue: [^ self].
	
	(self selectedClassOrMetaClass >> method selector) removePartialMethod: method.
	self changed: #messageList.
	self messageListIndex: 0.
	
	self setClassOrganizer.
	"In case organization not cached"
	confirmation = 2 ifTrue: [self systemNavigation browseAllCallsOn: method selector]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 14:46:04.694'!
selectedLayer
	"This returns the name of the layer (as symbol), not the layer object."
	
	^ self selectedLayerIndex = 0
		ifTrue: [ self class allLayersMarker ]
		ifFalse: [ self contextLayerList at: self selectedLayerIndex ]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/12/2012 12:45'!
selectedLayerIndex
	^ selectedLayerIndex! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'tfel 2/23/2012 14:43:49.154'!
selectedLayerIndex: anObject
	
	selectedLayerIndex := anObject.
	self messageCategoryListIndex: 1. "First just reset the variable, later do the real updates."
	self messageListIndex: 0.
	self
		changed: #selectedLayerIndex;
		changed: #contextLayerList;
		changed: #messageCategoryList;
		changed: #relabel;
		contentsChanged;
		messageCategoryListIndex: 1. "Select the --all-- category, deselect messages."! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/22/2012 23:08:24.183'!
selectedMessage
	"If the selected message is a normal CompiledMethods (the object then is the selector-symbol), use the super-version.
	Else, get the source from the special selected partial method."
	
	| messageName |
	messageName := self selectedMethod.
	messageName ifNil: [ ^ '' ].
	messageName isSymbol ifTrue: [ ^ super selectedMessage ].
	^ messageName getSource "is a CSPartialMethod"! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:41:58.076'!
selectedMessageCategoryName
	"Be tolerant, when messageCategoryListIndex is too big."
	
	self messageCategoryListIndex = 0 ifTrue: [ ^ nil ].
	^ self messageCategoryListIndex <= self messageCategoryList size
		ifTrue: [ self messageCategoryList at: self messageCategoryListIndex ]! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/22/2012 23:06:18.598'!
selectedMessageName
	"The result of the super-call might be a CSPartialMethod, "
	
	^ super selectedMessageName ifNotNilDo: #asSymbol! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/22/2012 23:00:29.567'!
selectedMethod
	"Access either the symbol or the CSPartialMethod currently selected."
	
	^ super selectedMessageName! !
CSBrowser initialize!
